﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using FlaUI.Core.AutomationElements;
using FlaUI.UIA3;
using FlaUI.UIA3.Patterns;

namespace LogonShell
{
    internal class Logon
    {
        [DllImport("User32.dll")]
        static extern int SetForegroundWindow(IntPtr point);
        [DllImport("user32.dll")]
        static extern bool SendMessage(IntPtr hWnd, uint Msg, int wParam, int lParam);
        [DllImport("user32.dll", SetLastError = true)]
        static extern IntPtr FindWindow(string lpClassName, string lpWindowName);
        public static void Login(string user, string password, bool IsLastUser)
        {
            Process p = Process.GetProcessesByName("LogonUI").FirstOrDefault();
            if (p != null)
            {
                BackgroundForm.form.StopWorker();
                string pwd = new string(password.Where(c => !char.IsControl(c)).ToArray()); // Need to sanitize it
                var app = FlaUI.Core.Application.Attach(p);
                using (var automation = new UIA3Automation())
                {
                    Window window;
                    AutomationElement[] items;
                    IntPtr h = app.MainWindowHandle;
                    SetForegroundWindow(h);
                    SendKeys.SendWait("{Backspace}");
                    Thread.Sleep(200);
                    if (!IsLastUser)
                    {
                        window = app.GetMainWindow(automation);
                        items = window.FindAllDescendants();
                        foreach (var item in items)
                        {
                            string name;
                            try
                            {
                                name = item.Name;
                                if (name.Contains(user))
                                {
                                    BackgroundForm.form.MakeTransparent();
                                    item.Click();
                                    BackgroundForm.form.RemoveTransparent();
                                }
                                Thread.Sleep(200);
                            }
                            catch (Exception)
                            {

                            }
                        }
                    }
                    window = app.GetMainWindow(automation);
                    items = window.FindAllDescendants();
                    SetForegroundWindow(h);
                    window.FindAllDescendants(cf => cf.ByControlType(FlaUI.Core.Definitions.ControlType.Edit)).First().Focus();
                    if (!string.IsNullOrEmpty(pwd))
                        SendKeys.SendWait(pwd);
                    SendKeys.SendWait("{Enter}");
                }
                BackgroundForm.form.StartWorker();
            }
            else
                throw new Exception("LogonUI not found!");
        }
        public static void WaitUntilLoggedOn()
        {
            Process p = Process.GetProcessesByName("LogonUI").FirstOrDefault();
            do
            {
                p = Process.GetProcessesByName("LogonUI").FirstOrDefault();
                Thread.Sleep(100);
            } while (p != null);
        }
    }
}
