﻿using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Security.Principal;
using System.Threading;
using System.Windows.Forms;

namespace LogonShell
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            Mutex mutex = new System.Threading.Mutex(false, "ClassicLogonShell");
            try
            {
                if (mutex.WaitOne(0, false))
                {
                    IniFile settings = new IniFile(Settings.Default);
                    if (!File.Exists(settings.Path) || (settings.KeyExists(1) && Boolean.Parse(settings.Read(1))))
                        settings.Reset();
                    else if (!settings.KeyExists(0) || settings.Read(0) != Settings.ProgramVersion)
                        settings.Update();
                    IniFile Locale = new IniFile(Settings.Locale,settings.Read(4));
                    if (settings.KeyExists(2) && Boolean.Parse(settings.Read(2)) || !File.Exists(Locale.Path))
                        Locale.Reset();
                    else if (!Locale.KeyExists(0) || Locale.Read(0) != Settings.ProgramVersion)
                        Locale.Update();
                    Settings.Initialize(args);
                    if (Settings.Read(28).ToLower() != "classic")
                        Application.EnableVisualStyles();
                    if (!(args.Length > 0 && args[0] == "/quiet"))
                        Application.Run(new BackgroundForm());
                }
                else
                {
                    // MessageBox.Show("An instance of the application is already running.");  Do Nothing
                }
            }
            finally
            {
                if (mutex != null)
                {
                    mutex.Close();
                }
            }
        }
    }
}
