﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace LogonShell
{
	public partial class SecondaryBackgrounds : Form
	{
		LogOnForm f1;

		public SecondaryBackgrounds(LogOnForm Form1, Screen ShownScreen)
		{
			InitializeComponent();
			Location = ShownScreen.WorkingArea.Location;
            Rectangle screen = ShownScreen.Bounds;
			Size = screen.Size;
			BackColor = ColorTranslator.FromHtml(Settings.Read(6));
			if (Settings.Read(7).ToLower() != "none" && Boolean.Parse(Settings.Read(8)))
			{
				var image = Image.FromFile(Settings.Read(7));
				pictureBox1.Location = new System.Drawing.Point(Int32.Parse(Settings.Read(9)), Int32.Parse(Settings.Read(10)));
				if (Int32.Parse(Settings.Read(12))>0)
				{
					if (Settings.Read(13)=="X")
                    {
                        pictureBox1.Width = (int)Math.Round((float)screen.Width / 100 * Int32.Parse(Settings.Read(12)));
                        pictureBox1.Height = (int)Math.Round((float)image.Height / image.Width * pictureBox1.Width);
                    }
					else if (Settings.Read(13) == "Y")
                    {
                        pictureBox1.Height = (int)Math.Round((float)screen.Height / 100 * Int32.Parse(Settings.Read(12)));
                        pictureBox1.Width = (int)Math.Round((float)image.Width / image.Height * pictureBox1.Height);
                    }
					else
                    {
                        pictureBox1.Width = (int)Math.Round((float)screen.Width / 100 * Int32.Parse(Settings.Read(12)));
                        pictureBox1.Height = (int)Math.Round((float)screen.Height / 100 * Int32.Parse(Settings.Read(12)));
                    }
                }
                else
				{
					if (Settings.Read(11).ToLower()=="auto")
                    {
                        pictureBox1.Width = image.Width;
                        pictureBox1.Height = image.Height;
                    }
					else
                    {
                        pictureBox1.Width = Int32.Parse(Settings.Read(11));
                        pictureBox1.Height = (int)Math.Round((float)image.Height / image.Width * pictureBox1.Width);
                    }
				}
                pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
				pictureBox1.Image = image;
			}
			f1 = Form1;
			Shown += BackgroundForm_Shown;
        }

		private void BackgroundForm_Shown(object sender, EventArgs e)
		{
			f1.Show();
		}

		private void BackgroundForm_FormClosing(object sender, FormClosingEventArgs e)
		{
			if (e.CloseReason == CloseReason.UserClosing)
				e.Cancel = true;
		}

		private void BackgroundForm_Activated(object sender, EventArgs e)
		{
			f1.Activate();
		}
	}
}
